Skip to content

IT Automation

The IT Automation service collection provides operations for managing automation policies, executions, jobs, and templates. Create and manage workflows for automated IT processes across your CrowdStrike environment.

LanguageLast Update
Pythonv1.6.1
PowerShellv2.2.9
Gov0.20.0
TypeScriptv0.6.0
Rustv0.7.0
Rubyv1.2.0
OperationDescription
ITAutomationGetAssociatedTasks
get_associated_tasks
Retrieve tasks associated with the provided file ID
ITAutomationCombinedScheduledTasks
scheduled_task_details
Returns full details of scheduled tasks matching the filter query parameter
ITAutomationRunLiveQuery
run_live_query
Start a new task execution from the provided query data in the request and return the initiated task executions
ITAutomationGetTaskExecutionsByQuery
get_executions_by_query
Retrieve task executions by query
ITAutomationGetTaskGroupsByQuery
get_task_groups_by_query
Retrieve task groups by query
ITAutomationGetTasksByQuery
get_tasks_by_query
Retrieve tasks by query
ITAutomationGetPolicies
get_policies
Retrieve policies
ITAutomationCreatePolicy
create_policy
Create a new policy of the specified type
ITAutomationUpdatePolicies
update_policy
Update a new policy of the specified type
ITAutomationDeletePolicy
delete_policy
Delete a policy
ITAutomationUpdatePolicyHostGroups
update_policy_host_groups
Update policy host groups
ITAutomationUpdatePoliciesPrecedence
update_policies_precedence
Update policies precedence
ITAutomationGetScheduledTasks
get_scheduled_task
Retrieve scheduled tasks
ITAutomationCreateScheduledTask
create_scheduled_task
Create a scheduled task from the given request
ITAutomationUpdateScheduledTask
update_scheduled_task
Update an existing scheduled task with the supplied info
ITAutomationDeleteScheduledTasks
delete_scheduled_task
Delete scheduled tasks
ITAutomationCancelTaskExecution
cancel_execution
Cancel a task execution
ITAutomationGetTaskExecutionHostStatus
get_execution_host_status
Retrieve task execution host status
ITAutomationRerunTaskExecution
rerun_execution
Rerun the task execution specified in the request
ITAutomationGetExecutionResultsSearchStatus
get_execution_results_search_status
Retrieve execution results search status
ITAutomationStartExecutionResultsSearch
execution_results_search
Start an asynchronous task execution results search
ITAutomationGetExecutionResults
get_execution_results
Retrieve execution results
ITAutomationGetTaskExecution
get_execution
Retrieve a task execution
ITAutomationStartTaskExecution
start_execution
Start a new task execution from an existing task provided in the request and returns the initiated task executions
ITAutomationGetTaskGroups
get_task_group
Retrieve task groups
ITAutomationCreateTaskGroup
create_task_group
Create a task group
ITAutomationUpdateTaskGroup
update_task_group
Update a task group for a given ID
ITAutomationDeleteTaskGroups
delete_task_groups
Delete task groups
ITAutomationGetTasks
get_tasks
Retrieve tasks
ITAutomationCreateTask
create_task
Create a task with details from the given request
ITAutomationUpdateTask
update_task
Update a task with details from the given request
ITAutomationDeleteTask
delete_task
Delete a task
ITAutomationQueryPolicies
query_policies
Query policies
ITAutomationSearchScheduledTasks
search_scheduled_tasks
Search scheduled tasks
ITAutomationSearchTaskExecutions
search_task_executions
Search task executions
ITAutomationSearchTaskGroups
search_task_groups
Search task groups
ITAutomationSearchTasks
search_tasks
Search tasks
ITAutomationGetUserGroup
get_user_group
Returns user groups for each provided id
ITAutomationCreateUserGroup
create_user_group
Creates a user group from the given request
ITAutomationUpdateUserGroup
update_user_group
Update a user group for a given id
ITAutomationDeleteUserGroup
delete_user_groups
Deletes user groups for each provided ids
ITAutomationSearchUserGroup
search_user_groups
Returns the list of user group ids matching the filter query parameter. It can be used together with the entities endpoint to retrieve full information on user groups

Retrieve tasks associated with the provided file ID

GET /it-automation/combined/associated-tasks/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_associated_tasks
NameTypeData typeDescription
idquerystringThe ID of the file to fetch associated tasks for
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_associated_tasks(id="string",
filter="string",
sort="string",
offset=integer,
limit=integer)
print(response)

Returns full details of scheduled tasks matching the filter query parameter

GET /it-automation/combined/scheduled-tasks/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 scheduled_task_details
NameTypeData typeDescription
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.scheduled_task_details(filter="string",
sort="string",
offset=integer,
limit=integer)
print(response)

Start a new task execution from the provided query data in the request and return the initiated task executions

POST /it-automation/entities/live-query-execution/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 run_live_query
NameTypeData typeDescription
bodybodydictionaryFull body payload provided as a dictionary
discover_new_hostsbodybooleanFlag indicating if this task can discover new hosts
discover_offline_hostsbodybooleanFlag indicating if this task can discover offline hosts
distributebodybooleanFlag indicating if this task is distributed
expiration_intervalbodystringTask expiration interval
guardrailsbodydictionaryTask guardrails (limiters)
osquerybodystringOS Query content
output_parser_configbodydictionaryOutput parser configuration
queriesbodydictionaryQueries to perform
targetbodystringExecution target
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.run_live_query(discover_new_hosts=boolean,
discover_offline_hosts=boolean,
distribute=boolean,
expiration_interval="string",
guardrails={},
osquery="string",
output_parser_config={},
queries={},
target="string")
print(response)

Retrieve task executions by query

GET /it-automation/combined/task-executions/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_executions_by_query
NameTypeData typeDescription
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_executions_by_query(filter="string",
sort="string",
offset=integer,
limit="string")
print(response)

Retrieve task groups by query

GET /it-automation/combined/task-groups/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_task_groups_by_query
NameTypeData typeDescription
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_task_groups_by_query(filter="string",
sort="string",
offset=integer,
limit=integer)
print(response)

Retrieve tasks by query

GET /it-automation/combined/tasks/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_tasks_by_query
NameTypeData typeDescription
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_tasks_by_query(filter="string",
sort="string",
offset=integer,
limit=integer)
print(response)

Retrieve policies

GET /it-automation/entities/policies/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_policies
NameTypeData typeDescription
idsquerystring or list of stringsOne or more policy IDs
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_policies(ids=id_list)
print(response)

Create a new policy of the specified type

New policies are always added at the end of the precedence list for the provided policy type.

POST /it-automation/entities/policies/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 create_policy
NameTypeData typeDescription
bodybodydictionaryFull body payload provided as a dictionary. Not required if using other keywords
namebodystringPolicy name. Max: 100 characters
descriptionbodystringPolicy description. Max: 500 characters
platformbodystringExecution host platform. Allowed values: Windows, Linux, Mac
enable_script_executionbodybooleanEnable or disable script execution
enable_python_executionbodybooleanEnable or disable Python execution
enable_os_querybodybooleanEnable or disable OS Query
execution_timeoutbodyintegerSpecifies the timeout value for executions
execution_timeout_unitbodystringExecution timeout unit. Allowed values: Hours, Minutes
cpu_throttlebodyintegerSpecifies the CPU throttle value
cpu_schedulingbodystringSets priority to determine the order in which a query process will run on a host’s CPU
memory_pressure_levelbodystringSets memory pressure level to control system resource allocation during task execution
memory_allocationbodyintegerSpecifies the memory allocation value
memory_allocation_unitbodystringMemory allocation unit. Allowed values: MB, GB
concurrent_host_limitbodyintegerSpecifies the maximum number of concurrent hosts
concurrent_task_limitbodyintegerSpecifies the maximum number of concurrent tasks
concurrent_host_file_transfer_limitbodyintegerSpecifies the maximum number of concurrent file transfers
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.create_policy(name="string",
description="string",
platform="string",
enable_script_execution=boolean,
enable_python_execution=boolean,
enable_os_query=boolean,
execution_timeout=integer,
execution_timeout_unit="string",
cpu_throttle=integer,
cpu_scheduling="string",
memory_pressure_level="string",
memory_allocation=integer,
memory_allocation_unit="string",
concurrent_host_limit=integer,
concurrent_task_limit=integer,
concurrent_host_file_transfer_limit=integer)
print(response)

Update a new policy of the specified type

PATCH /it-automation/entities/policies/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 update_policy
NameTypeData typeDescription
bodybodydictionaryFull body payload provided as a dictionary. Not required if using other keywords
idbodystringA valid policy ID representing the policy to be updated. Required
namebodystringPolicy name. Max: 100 characters
descriptionbodystringPolicy description. Max: 500 characters
is_enabledbodybooleanFlag controlling whether the policy is active
enable_script_executionbodybooleanEnable or disable script execution
enable_python_executionbodybooleanEnable or disable Python execution
enable_os_querybodybooleanEnable or disable OS Query
execution_timeoutbodyintegerSpecifies the timeout value for executions
execution_timeout_unitbodystringExecution timeout unit. Allowed values: Hours, Minutes
cpu_throttlebodyintegerSpecifies the CPU throttle value
cpu_schedulingbodystringSets priority to determine the order in which a query process will run on a host’s CPU
memory_pressure_levelbodystringSets memory pressure level to control system resource allocation during task execution
memory_allocationbodyintegerSpecifies the memory allocation value
memory_allocation_unitbodystringMemory allocation unit. Allowed values: MB, GB
concurrent_host_limitbodyintegerSpecifies the maximum number of concurrent hosts
concurrent_task_limitbodyintegerSpecifies the maximum number of concurrent tasks
concurrent_host_file_transfer_limitbodyintegerSpecifies the maximum number of concurrent file transfers
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_policy(id="string",
name="string",
description="string",
is_enabled=boolean,
enable_script_execution=boolean,
enable_python_execution=boolean,
enable_os_query=boolean,
execution_timeout=integer,
execution_timeout_unit="string",
cpu_throttle=integer,
cpu_scheduling="string",
memory_pressure_level="string",
memory_allocation=integer,
memory_allocation_unit="string",
concurrent_host_limit=integer,
concurrent_task_limit=integer,
concurrent_host_file_transfer_limit=integer)
print(response)

Delete a policy

DELETE /it-automation/entities/policies/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 delete_policy
NameTypeData typeDescription
idsquerystring or list of stringsOne or more policy IDs to delete
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.delete_policy(ids=id_list)
print(response)

Update policy host groups

PATCH /it-automation/entities/policies-host-groups/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 update_policy_host_groups
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format
policy_idbodystringPolicy ID
host_group_idsbodyarrayList of host group IDs
actionbodystringAction to perform
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.update_policy_host_groups(action="string",
host_group_ids=id_list,
policy_id="string")
print(response)

Update policies precedence

PATCH /it-automation/entities/policies-precedence/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 update_policies_precedence
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format
idsbodyarrayList of policy IDs in precedence order
parametersquerydictionaryFull query string parameters payload in JSON format
platformquerystringThe policy platform for which to set the precedence order
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.update_policies_precedence(ids=id_list, platform="string")
print(response)

Retrieve scheduled tasks

GET /it-automation/entities/scheduled-tasks/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_scheduled_task
NameTypeData typeDescription
idsquerystring or list of stringsOne or more scheduled task IDs
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_scheduled_task(ids=id_list)
print(response)

Create a scheduled task from the given request

POST /it-automation/entities/scheduled-tasks/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 create_scheduled_task
NameTypeData typeDescription
bodybodydictionaryFull body payload provided as a dictionary
execution_argsbodydictionaryArguments to provide to the task when executed
discover_new_hostsbodybooleanAllow the task to discover new hosts
discover_offline_hostsbodybooleanAllow the task to discover offline hosts
distributebodybooleanDistribute the task
expiration_intervalbodystringTask expiration interval
guardrailsbodydictionaryTask execution guardrails (limiters)
idbodystringThe id of the scheduled task to update
is_activebodybooleanFlag indicating if the task is active
schedulebodydictionaryTask schedule
targetbodystringTask target
task_idbodystringTask ID
trigger_conditionbodylist of dictionariesTask trigger conditions
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.create_scheduled_task(arguments={},
discover_new_hosts=boolean,
discover_offline_hosts=boolean,
distribute=boolean,
expiration_interval="string",
guardrails={},
id="string",
is_active=boolean,
schedule={},
target="string",
task_id="string",
trigger_condition=[{"key": "value"}])
print(response)

Update an existing scheduled task with the supplied info

PATCH /it-automation/entities/scheduled-tasks/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 update_scheduled_task
NameTypeData typeDescription
bodybodydictionaryFull body payload provided as a dictionary. Not required if using other keywords
discover_new_hostsbodybooleanAllow the task to discover new hosts
discover_offline_hostsbodybooleanAllow the task to discover offline hosts
distributebodybooleanDistribute the task
execution_argsbodydictionaryArguments to provide to the task when executed
expiration_intervalbodystringTask expiration interval
guardrailsbodydictionaryTask execution guardrails (limiters)
idquerystringThe id of the scheduled task to update
is_activebodybooleanFlag indicating if the task is active
parametersquerydictionaryFull query string parameters payload in JSON format
schedulebodydictionaryTask schedule
targetbodystringTask target
task_idbodystringTask ID
trigger_conditionbodylist of dictionariesTask trigger conditions
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_scheduled_task(discover_new_hosts=boolean,
discover_offline_hosts=boolean,
distribute=boolean,
execution_args={},
expiration_interval="string",
guardrails={},
id="string",
is_active=boolean,
schedule={},
target="string",
task_id="string",
trigger_condition=[{"key": "value"}])
print(response)

Delete scheduled tasks

DELETE /it-automation/entities/scheduled-tasks/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 delete_scheduled_task
NameTypeData typeDescription
idsquerystring or list of stringsOne or more scheduled task IDs to delete
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.delete_scheduled_task(ids=id_list)
print(response)

Cancel a task execution

POST /it-automation/entities/task-execution-cancel/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 cancel_execution
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format
task_execution_idbodystringTask execution ID
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.cancel_execution(task_execution_id="string")
print(response)

Retrieve task execution host status

GET /it-automation/entities/task-execution-host-status/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_execution_host_status
NameTypeData typeDescription
idsquerystring or list of stringsTask execution ID
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_execution_host_status(ids=id_list,
filter="string",
sort="string",
offset=integer,
limit=integer)
print(response)

Rerun the task execution specified in the request

POST /it-automation/entities/task-execution-rerun/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 rerun_execution
NameTypeData typeDescription
bodybodydictionaryFull body payload provided as a dictionary. Not required if using other keywords
run_typebodystringTask run type
task_execution_idbodystringTask execution ID
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.rerun_execution(run_type="string", task_execution_id="string")
print(response)

ITAutomationGetExecutionResultsSearchStatus

Section titled “ITAutomationGetExecutionResultsSearchStatus”

Retrieve execution results search status

GET /it-automation/entities/task-execution-results-search/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_execution_results_search_status
NameTypeData typeDescription
idquerystringSearch ID
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_execution_results_search_status(id="string")
print(response)

Start an asynchronous task execution results search

Poll ITAutomationGetExecutionResultsSearchStatus to determine when the search is complete.

POST /it-automation/entities/task-execution-results-search/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 execution_results_search
NameTypeData typeDescription
bodybodydictionaryFull body payload provided as a dictionary. Not required if using other keywords
endbodystringTask end
filter_expressionsbodystring or list of stringsFilter expressions to apply
group_by_fieldsbodystring or list of stringsFields to use to group results
startbodystringTask start
task_execution_idbodystringTask execution ID
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.execution_results_search(end="string",
filter_expressions=id_list,
group_by_fields=id_list,
start="string",
task_execution_id="string")
print(response)

Retrieve execution results

GET /it-automation/entities/task-execution-results/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_execution_results
NameTypeData typeDescription
idquerystringSearch ID
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
sortquerystringSort results by one of the fields in the event results, either asc (ascending) or desc (descending)
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_execution_results(id="string",
offset=integer,
limit=integer,
sort="string")
print(response)

Retrieve a task execution

GET /it-automation/entities/task-executions/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_execution
NameTypeData typeDescription
idsquerystring or list of stringsTask execution ID
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_execution(ids=id_list)
print(response)

Start a new task execution from an existing task provided in the request and returns the initiated task executions

POST /it-automation/entities/task-executions/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 start_execution
NameTypeData typeDescription
argumentsbodydictionaryArguments to pass to the execution
bodybodydictionaryFull body payload provided as a dictionary. Not required if using other keywords
discover_new_hostsbodybooleanAllow the task execution to discover new hosts
discover_offline_hostsbodybooleanAllow the task execution to discover offline hosts
distributebodybooleanDistribute this task
expiration_intervalbodystringTask expiration interval
guardrailsbodydictionaryTask execution guardrails (limiters)
targetbodystringTask target
task_idbodystringTask ID
trigger_conditionsbodylist of dictionariesList of task triggers
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.start_execution(arguments={},
discover_new_hosts=boolean,
discover_offline_hosts=boolean,
distribute=boolean,
expiration_interval="string",
guardrails={},
target="string",
task_id="string",
trigger_conditions=[{"key": "value"}])
print(response)

Retrieve task groups

GET /it-automation/entities/task-groups/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_task_group
NameTypeData typeDescription
idsquerystring or list of stringsOne or more task group IDs
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_task_group(ids=id_list)
print(response)

Create a task group

POST /it-automation/entities/task-groups/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 create_task_group
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format
access_typebodystringAccess type for the task group
assigned_user_group_idsbodystring or list of stringsAssigned user group IDs
assigned_user_idsbodystring or list of stringsAssigned user IDs
namebodystringTask group name
descriptionbodystringTask group description
task_idsbodystringTask IDs to add to the group. String or list of strings.
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.create_task_group(access_type="string",
assigned_user_group_ids=id_list,
assigned_user_ids=id_list,
description="string",
name="string",
task_ids=id_list)
print(response)

Update a task group for a given ID

PATCH /it-automation/entities/task-groups/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 update_task_group
NameTypeData typeDescription
access_typebodystringTask group access type
add_assigned_user_group_idsbodystring or list of stringsUser group IDs to add
add_assigned_user_idsbodystring or list of stringsUser IDs to add
add_task_idsbodystring or list of stringsTask IDs to add to the group
bodybodydictionaryFull body payload provided as a dictionary. Not required if using other keywords
descriptionbodystringTask group description
idquerystringThe ID of the task group to update
namebodystringTask group name
remove_assigned_user_group_idsbodystring or list of stringsUser group IDs to be removed
remove_assigned_user_idsbodystring or list of stringsUser IDs to be removed
remove_task_idsbodystring or list of stringsTask IDs to be removed
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.update_task_group(access_type="string",
add_assigned_user_group_ids=id_list,
add_assigned_user_ids=id_list,
add_task_ids=id_list,
description="string",
id="string",
name="string",
removed_assigned_user_group_ids=id_list,
remove_assigned_user_ids=id_list,
remove_task_ids=id_list)
print(response)

Delete task groups

DELETE /it-automation/entities/task-groups/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 delete_task_groups
NameTypeData typeDescription
idsquerystring or list of stringsOne or more task group IDs to delete
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.delete_task_groups(ids=id_list)
print(response)

Retrieve tasks

GET /it-automation/entities/tasks/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_tasks
NameTypeData typeDescription
idsquerystring or list of stringsOne or more task IDs
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_tasks(ids=id_list)
print(response)

Create a task with details from the given request

POST /it-automation/entities/tasks/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 create_task
NameTypeData typeDescription
access_typebodystringTask access type
add_assigned_user_group_idsbodystring or list of stringsUser group IDs to add
add_assigned_user_idsbodystring or list of stringsUser IDs to add
bodybodydictionaryFull body payload provided as a dictionary. Not required if using other keywords
descriptionbodystringTask description
namebodystringTask name
os_querybodystringOS query detail
output_parser_configbodydictionaryParser output configuration
queriesbodydictionaryQueries to perform (by OS)
remediationsbodydictionaryRemediations to perform (by OS)
remove_assigned_user_group_idsbodystring or list of stringsUser group IDs to be removed
remove_assigned_user_idsbodystring or list of stringsUser IDs to be removed
targetbodystringTask target
task_group_idbodystringTask group ID
task_parametersbodylist of dictionariesTask parameters
task_typebodystringTask type
trigger_conditionbodylist of dictionariesTrigger conditions
verification_conditionbodylist of dictionariesVerification conditions
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.create_task(access_type="string",
add_assigned_user_group_ids=id_list,
add_assigned_user_ids=id_list,
description="string",
name="string",
os_query="string",
output_parser_config={},
queries={},
remediations={},
removed_assigned_user_group_ids=id_list,
remove_assigned_user_ids=id_list,
target="string",
task_parameters=[{"key": "value"}],
task_group_id="string",
task_type="string",
trigger_condition=[{"key": "value"}],
verification_condition=[{"key": "value"}])
print(response)

Update a task with details from the given request

PATCH /it-automation/entities/tasks/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 update_task
NameTypeData typeDescription
access_typebodystringTask access type
add_assigned_user_group_idsbodystring or list of stringsUser group IDs to add
add_assigned_user_idsbodystring or list of stringsUser IDs to add
bodybodydictionaryFull body payload provided as a dictionary. Not required if using other keywords
descriptionbodystringTask description
idquerystringID of the task to update. Use ITAutomationSearchTasks to fetch IDs
namebodystringTask name
os_querybodystringOS query detail
output_parser_configbodydictionaryParser output configuration
parametersquerydictionaryFull query string parameters payload in JSON format
queriesbodydictionaryQueries to perform (by OS)
remediationsbodydictionaryRemediations to perform (by OS)
remove_assigned_user_group_idsbodystring or list of stringsUser group IDs to be removed
remove_assigned_user_idsbodystring or list of stringsUser IDs to be removed
targetbodystringTask target
task_group_idbodystringTask group ID
task_parametersbodylist of dictionariesTask parameters
task_typebodystringTask type
trigger_conditionbodylist of dictionariesTrigger conditions
verification_conditionbodylist of dictionariesVerification conditions
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.update_task(access_type="string",
add_assigned_user_group_ids=id_list,
add_assigned_user_ids=id_list,
description="string",
id=id_list,
name="string",
os_query="string",
output_parser_config={},
queries={},
remediations={},
removed_assigned_user_group_ids=id_list,
remove_assigned_user_ids=id_list,
target="string",
task_parameters=[{"key": "value"}],
task_group_id="string",
task_type="string",
trigger_condition=[{"key": "value"}],
verification_condition=[{"key": "value"}])
print(response)

Delete a task

DELETE /it-automation/entities/tasks/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 delete_task
NameTypeData typeDescription
idsquerystring or list of stringsOne or more task IDs to delete
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.delete_task(ids=id_list)
print(response)

Query policies

GET /it-automation/queries/policies/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 query_policies
NameTypeData typeDescription
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
platformquerystringRequired. The platform of policies to retrieve. Allowed values: Windows, Mac, Linux
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.query_policies(offset=integer,
limit=integer,
sort="string",
platform="string")
print(response)

Search scheduled tasks

GET /it-automation/queries/scheduled-tasks/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 search_scheduled_tasks
NameTypeData typeDescription
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.search_scheduled_tasks(filter="string",
sort="string",
offset=integer,
limit=integer)
print(response)

Search task executions

GET /it-automation/queries/task-executions/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 search_task_executions
NameTypeData typeDescription
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.search_task_executions(filter="string",
sort="string",
offset=integer,
limit=integer)
print(response)

Search task groups

GET /it-automation/queries/task-groups/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 search_task_groups
NameTypeData typeDescription
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.search_task_groups(filter="string",
sort="string",
offset=integer,
limit="string")
print(response)

Search tasks

GET /it-automation/queries/tasks/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 search_tasks
NameTypeData typeDescription
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.search_tasks(filter="string",
sort="string",
offset=integer,
limit=integer)
print(response)

Returns user groups for each provided id

GET /it-automation/entities/it-user-groups/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 get_user_group
NameTypeData typeDescription
idsquerylist of stringsUser group IDs
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_user_group(ids=id_list)
print(response)

Creates a user group from the given request

POST /it-automation/entities/it-user-groups/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 create_user_group
NameTypeData typeDescription
bodybodydictionaryRequired parameter.

Full body payload in JSON format
descriptionbodystringDescription of the user group.
namebodystringName of the user group.
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.create_user_group(description="string", name="string")
print(response)

Update a user group for a given id

PATCH /it-automation/entities/it-user-groups/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 update_user_group
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format. Not required if using other keywords.
add_user_idsbodylist of stringsList of user IDs to add.
descriptionbodystringThe updated user group description.
idquerystringThe ID of the user group to update.
namebodystringThe updated user group name.
remove_user_idsbodylist of stringsList of user IDs to remove.
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.update_user_group(add_user_ids=id_list,
description="string",
name="string",
id="string",
remove_user_ids=id_list)
print(response)

Deletes user groups for each provided ids

DELETE /it-automation/entities/it-user-groups/v1
Scope IT Automation: WRITE Consumes · Produces application/json
PEP 8 delete_user_groups
NameTypeData typeDescription
idsquerylist of stringsUser group IDs
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.delete_user_groups(ids=id_list)
print(response)

Returns the list of user group ids matching the filter query parameter. It can be used together with the entities endpoint to retrieve full information on user groups

GET /it-automation/queries/it-user-groups/v1
Scope IT Automation: READ Consumes · Produces application/json
PEP 8 search_user_groups
NameTypeData typeDescription
filterquerystringThe filter expression that should be used to limit the results
sortquerystringThe sort expression that should be used to sort the results
offsetqueryintegerStarting index for record retrieval
limitqueryintegerThe maximum records to return
parametersquerydictionaryFull query string parameters payload in JSON format
from falconpy import ITAutomation
falcon = ITAutomation(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.search_user_groups(filter="string",
sort="string",
offset=integer,
limit=integer)
print(response)